/*
 *	 libodbc.cpp
 *	 Generated by sql2class v1.8.1 by (C) AH 2000-2006
 *	  using command line
 *	  $ sql2class -global- -lib libodbc -namespace sql -overwrite odbc.sql -odbc
 *	 Date: Fri Mar 31 10:05:11 2006
 */

/*
Copyright (C) 2001-2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifdef _WIN32
#pragma warning(disable:4786)
#endif

#include "libodbc.h"

namespace sql {

/**
 **  Begin class 'Odbctable'
 **/

Odbctable::Odbctable(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Odbctable::Odbctable(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Odbctable::Odbctable(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Odbctable::~Odbctable()
{
}


void Odbctable::select(const std::string& sql)
{
	spawn(sql);
}


unsigned __int64 Odbctable::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into odbctable(table_cat,table_schem,table_name,table_type,remarks)";
	sql += " values('" + q.GetDatabase().safestr(this -> table_cat) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_schem) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_name) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_type) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> remarks) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned __int64 inserted_id = q.insert_id();
	return inserted_id;
}


void Odbctable::save()
{
	if (new_object)
		insert();
}


std::string Odbctable::xml()
{
	Query q(*database);
	std::string dest;
	dest = "<ODBCTABLE>";
	dest += "<TABLE_CAT>" + q.GetDatabase().xmlsafestr(this -> table_cat) + "</TABLE_CAT>";
	dest += "<TABLE_SCHEM>" + q.GetDatabase().xmlsafestr(this -> table_schem) + "</TABLE_SCHEM>";
	dest += "<TABLE_NAME>" + q.GetDatabase().xmlsafestr(this -> table_name) + "</TABLE_NAME>";
	dest += "<TABLE_TYPE>" + q.GetDatabase().xmlsafestr(this -> table_type) + "</TABLE_TYPE>";
	dest += "<REMARKS>" + q.GetDatabase().xmlsafestr(this -> remarks) + "</REMARKS>";
	dest += "</ODBCTABLE>";
	return dest;
}


std::string Odbctable::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	dest = "<ODBCTABLE " + tag + "=\"" + xvalx + "\">";
	dest += "<TABLE_CAT>" + q.GetDatabase().xmlsafestr(this -> table_cat) + "</TABLE_CAT>";
	dest += "<TABLE_SCHEM>" + q.GetDatabase().xmlsafestr(this -> table_schem) + "</TABLE_SCHEM>";
	dest += "<TABLE_NAME>" + q.GetDatabase().xmlsafestr(this -> table_name) + "</TABLE_NAME>";
	dest += "<TABLE_TYPE>" + q.GetDatabase().xmlsafestr(this -> table_type) + "</TABLE_TYPE>";
	dest += "<REMARKS>" + q.GetDatabase().xmlsafestr(this -> remarks) + "</REMARKS>";
	dest += "</ODBCTABLE>";
	return dest;
}


size_t Odbctable::num_cols()
{
	return 5;
}


void Odbctable::clear()
{
	this -> table_cat = "";
	this -> table_schem = "";
	this -> table_name = "";
	this -> table_type = "";
	this -> remarks = "";
}


void Odbctable::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select table_cat,table_schem,table_name,table_type,remarks " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> table_cat = q.getstr(0);																				// 0 - table_cat varchar(255)
		this -> table_schem = q.getstr(1);																				// 1 - table_schem varchar(255)
		this -> table_name = q.getstr(2);																				// 2 - table_name varchar(255)
		this -> table_type = q.getstr(3);																				// 3 - table_type varchar(255)
		this -> remarks = q.getstr(4);																				// 4 - remarks varchar(255)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Odbctable::spawn(Query *qd,int offset)
{
	clear();

	this -> table_cat = qd -> getstr(0 + offset);																				// 0 - table_cat varchar(255)
	this -> table_schem = qd -> getstr(1 + offset);																				// 1 - table_schem varchar(255)
	this -> table_name = qd -> getstr(2 + offset);																				// 2 - table_name varchar(255)
	this -> table_type = qd -> getstr(3 + offset);																				// 3 - table_type varchar(255)
	this -> remarks = qd -> getstr(4 + offset);																				// 4 - remarks varchar(255)
}


// End of implementation of class 'Odbctable'

} // End of namespace
namespace sql {

/**
 **  Begin class 'Odbccolumn'
 **/

Odbccolumn::Odbccolumn(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Odbccolumn::Odbccolumn(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Odbccolumn::Odbccolumn(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Odbccolumn::~Odbccolumn()
{
}


void Odbccolumn::select(const std::string& sql)
{
	spawn(sql);
}


unsigned __int64 Odbccolumn::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into odbccolumn(table_cat,table_schem,table_name,column_name,data_type,type_name,column_size,buffer_length,decimal_digits,num_prec_radix,nullable,remarks,column_def,sql_data_type,sql_datetime_sub,char_octet_length,ordinal_position,is_nullable)";
	sql += " values('" + q.GetDatabase().safestr(this -> table_cat) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_schem) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_name) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> column_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> data_type);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> type_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> column_size);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> buffer_length);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> decimal_digits);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> num_prec_radix);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> nullable);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> remarks) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> column_def) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> sql_data_type);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> sql_datetime_sub);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> char_octet_length);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> ordinal_position);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> is_nullable) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned __int64 inserted_id = q.insert_id();
	return inserted_id;
}


void Odbccolumn::save()
{
	if (new_object)
		insert();
}


std::string Odbccolumn::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ODBCCOLUMN>";
	dest += "<TABLE_CAT>" + q.GetDatabase().xmlsafestr(this -> table_cat) + "</TABLE_CAT>";
	dest += "<TABLE_SCHEM>" + q.GetDatabase().xmlsafestr(this -> table_schem) + "</TABLE_SCHEM>";
	dest += "<TABLE_NAME>" + q.GetDatabase().xmlsafestr(this -> table_name) + "</TABLE_NAME>";
	dest += "<COLUMN_NAME>" + q.GetDatabase().xmlsafestr(this -> column_name) + "</COLUMN_NAME>";
	sprintf(slask,"<DATA_TYPE>%d</DATA_TYPE>",this -> data_type);
	dest += slask;
	dest += "<TYPE_NAME>" + q.GetDatabase().xmlsafestr(this -> type_name) + "</TYPE_NAME>";
	sprintf(slask,"<COLUMN_SIZE>%ld</COLUMN_SIZE>",this -> column_size);
	dest += slask;
	sprintf(slask,"<BUFFER_LENGTH>%ld</BUFFER_LENGTH>",this -> buffer_length);
	dest += slask;
	sprintf(slask,"<DECIMAL_DIGITS>%d</DECIMAL_DIGITS>",this -> decimal_digits);
	dest += slask;
	sprintf(slask,"<NUM_PREC_RADIX>%d</NUM_PREC_RADIX>",this -> num_prec_radix);
	dest += slask;
	sprintf(slask,"<NULLABLE>%d</NULLABLE>",this -> nullable);
	dest += slask;
	dest += "<REMARKS>" + q.GetDatabase().xmlsafestr(this -> remarks) + "</REMARKS>";
	dest += "<COLUMN_DEF>" + q.GetDatabase().xmlsafestr(this -> column_def) + "</COLUMN_DEF>";
	sprintf(slask,"<SQL_DATA_TYPE>%d</SQL_DATA_TYPE>",this -> sql_data_type);
	dest += slask;
	sprintf(slask,"<SQL_DATETIME_SUB>%d</SQL_DATETIME_SUB>",this -> sql_datetime_sub);
	dest += slask;
	sprintf(slask,"<CHAR_OCTET_LENGTH>%ld</CHAR_OCTET_LENGTH>",this -> char_octet_length);
	dest += slask;
	sprintf(slask,"<ORDINAL_POSITION>%ld</ORDINAL_POSITION>",this -> ordinal_position);
	dest += slask;
	dest += "<IS_NULLABLE>" + q.GetDatabase().xmlsafestr(this -> is_nullable) + "</IS_NULLABLE>";
	dest += "</ODBCCOLUMN>";
	return dest;
}


std::string Odbccolumn::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ODBCCOLUMN " + tag + "=\"" + xvalx + "\">";
	dest += "<TABLE_CAT>" + q.GetDatabase().xmlsafestr(this -> table_cat) + "</TABLE_CAT>";
	dest += "<TABLE_SCHEM>" + q.GetDatabase().xmlsafestr(this -> table_schem) + "</TABLE_SCHEM>";
	dest += "<TABLE_NAME>" + q.GetDatabase().xmlsafestr(this -> table_name) + "</TABLE_NAME>";
	dest += "<COLUMN_NAME>" + q.GetDatabase().xmlsafestr(this -> column_name) + "</COLUMN_NAME>";
	sprintf(slask,"<DATA_TYPE>%d</DATA_TYPE>",this -> data_type);
	dest += slask;
	dest += "<TYPE_NAME>" + q.GetDatabase().xmlsafestr(this -> type_name) + "</TYPE_NAME>";
	sprintf(slask,"<COLUMN_SIZE>%ld</COLUMN_SIZE>",this -> column_size);
	dest += slask;
	sprintf(slask,"<BUFFER_LENGTH>%ld</BUFFER_LENGTH>",this -> buffer_length);
	dest += slask;
	sprintf(slask,"<DECIMAL_DIGITS>%d</DECIMAL_DIGITS>",this -> decimal_digits);
	dest += slask;
	sprintf(slask,"<NUM_PREC_RADIX>%d</NUM_PREC_RADIX>",this -> num_prec_radix);
	dest += slask;
	sprintf(slask,"<NULLABLE>%d</NULLABLE>",this -> nullable);
	dest += slask;
	dest += "<REMARKS>" + q.GetDatabase().xmlsafestr(this -> remarks) + "</REMARKS>";
	dest += "<COLUMN_DEF>" + q.GetDatabase().xmlsafestr(this -> column_def) + "</COLUMN_DEF>";
	sprintf(slask,"<SQL_DATA_TYPE>%d</SQL_DATA_TYPE>",this -> sql_data_type);
	dest += slask;
	sprintf(slask,"<SQL_DATETIME_SUB>%d</SQL_DATETIME_SUB>",this -> sql_datetime_sub);
	dest += slask;
	sprintf(slask,"<CHAR_OCTET_LENGTH>%ld</CHAR_OCTET_LENGTH>",this -> char_octet_length);
	dest += slask;
	sprintf(slask,"<ORDINAL_POSITION>%ld</ORDINAL_POSITION>",this -> ordinal_position);
	dest += slask;
	dest += "<IS_NULLABLE>" + q.GetDatabase().xmlsafestr(this -> is_nullable) + "</IS_NULLABLE>";
	dest += "</ODBCCOLUMN>";
	return dest;
}


size_t Odbccolumn::num_cols()
{
	return 18;
}


void Odbccolumn::clear()
{
	this -> table_cat = "";
	this -> table_schem = "";
	this -> table_name = "";
	this -> column_name = "";
	this -> data_type = 0;
	this -> type_name = "";
	this -> column_size = 0;
	this -> buffer_length = 0;
	this -> decimal_digits = 0;
	this -> num_prec_radix = 0;
	this -> nullable = 0;
	this -> remarks = "";
	this -> column_def = "";
	this -> sql_data_type = 0;
	this -> sql_datetime_sub = 0;
	this -> char_octet_length = 0;
	this -> ordinal_position = 0;
	this -> is_nullable = "";
}


void Odbccolumn::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select table_cat,table_schem,table_name,column_name,data_type,type_name,column_size,buffer_length,decimal_digits,num_prec_radix,nullable,remarks,column_def,sql_data_type,sql_datetime_sub,char_octet_length,ordinal_position,is_nullable " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> table_cat = q.getstr(0);																				// 0 - table_cat varchar(255)
		this -> table_schem = q.getstr(1);																				// 1 - table_schem varchar(255)
		this -> table_name = q.getstr(2);																				// 2 - table_name varchar(255)
		this -> column_name = q.getstr(3);																				// 3 - column_name varchar(255)
		this -> data_type = q.getval(4);																				// 4 - data_type smallint
		this -> type_name = q.getstr(5);																				// 5 - type_name varchar(255)
		this -> column_size = q.getval(6);																				// 6 - column_size integer
		this -> buffer_length = q.getval(7);																				// 7 - buffer_length integer
		this -> decimal_digits = q.getval(8);																				// 8 - decimal_digits smallint
		this -> num_prec_radix = q.getval(9);																				// 9 - num_prec_radix smallint
		this -> nullable = q.getval(10);																				// 10 - nullable smallint
		this -> remarks = q.getstr(11);																				// 11 - remarks varchar(255)
		this -> column_def = q.getstr(12);																				// 12 - column_def varchar(255)
		this -> sql_data_type = q.getval(13);																				// 13 - sql_data_type smallint
		this -> sql_datetime_sub = q.getval(14);																				// 14 - sql_datetime_sub smallint
		this -> char_octet_length = q.getval(15);																				// 15 - char_octet_length integer
		this -> ordinal_position = q.getval(16);																				// 16 - ordinal_position integer
		this -> is_nullable = q.getstr(17);																				// 17 - is_nullable varchar(255)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Odbccolumn::spawn(Query *qd,int offset)
{
	clear();

	this -> table_cat = qd -> getstr(0 + offset);																				// 0 - table_cat varchar(255)
	this -> table_schem = qd -> getstr(1 + offset);																				// 1 - table_schem varchar(255)
	this -> table_name = qd -> getstr(2 + offset);																				// 2 - table_name varchar(255)
	this -> column_name = qd -> getstr(3 + offset);																				// 3 - column_name varchar(255)
	this -> data_type = qd -> getval(4 + offset);																				// 4 - data_type smallint
	this -> type_name = qd -> getstr(5 + offset);																				// 5 - type_name varchar(255)
	this -> column_size = qd -> getval(6 + offset);																				// 6 - column_size integer
	this -> buffer_length = qd -> getval(7 + offset);																				// 7 - buffer_length integer
	this -> decimal_digits = qd -> getval(8 + offset);																				// 8 - decimal_digits smallint
	this -> num_prec_radix = qd -> getval(9 + offset);																				// 9 - num_prec_radix smallint
	this -> nullable = qd -> getval(10 + offset);																				// 10 - nullable smallint
	this -> remarks = qd -> getstr(11 + offset);																				// 11 - remarks varchar(255)
	this -> column_def = qd -> getstr(12 + offset);																				// 12 - column_def varchar(255)
	this -> sql_data_type = qd -> getval(13 + offset);																				// 13 - sql_data_type smallint
	this -> sql_datetime_sub = qd -> getval(14 + offset);																				// 14 - sql_datetime_sub smallint
	this -> char_octet_length = qd -> getval(15 + offset);																				// 15 - char_octet_length integer
	this -> ordinal_position = qd -> getval(16 + offset);																				// 16 - ordinal_position integer
	this -> is_nullable = qd -> getstr(17 + offset);																				// 17 - is_nullable varchar(255)
}


// End of implementation of class 'Odbccolumn'

} // End of namespace
namespace sql {

/**
 **  Begin class 'Odbcspecialcolumn'
 **/

Odbcspecialcolumn::Odbcspecialcolumn(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Odbcspecialcolumn::Odbcspecialcolumn(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Odbcspecialcolumn::Odbcspecialcolumn(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Odbcspecialcolumn::~Odbcspecialcolumn()
{
}


void Odbcspecialcolumn::select(const std::string& sql)
{
	spawn(sql);
}


unsigned __int64 Odbcspecialcolumn::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into odbcspecialcolumn(scope,column_name,data_type,type_name,column_size,buffer_length,decimal_digits,pseudo_column)";
	{
		char slask[100];
		sprintf(slask," values(%d",this -> scope);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> column_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> data_type);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> type_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> column_size);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> buffer_length);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> decimal_digits);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> pseudo_column);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned __int64 inserted_id = q.insert_id();
	scope = inserted_id;
	return inserted_id;
}


void Odbcspecialcolumn::save()
{
	if (new_object)
		insert();
}


std::string Odbcspecialcolumn::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ODBCSPECIALCOLUMN>";
	sprintf(slask,"<SCOPE>%d</SCOPE>",this -> scope);
	dest += slask;
	dest += "<COLUMN_NAME>" + q.GetDatabase().xmlsafestr(this -> column_name) + "</COLUMN_NAME>";
	sprintf(slask,"<DATA_TYPE>%d</DATA_TYPE>",this -> data_type);
	dest += slask;
	dest += "<TYPE_NAME>" + q.GetDatabase().xmlsafestr(this -> type_name) + "</TYPE_NAME>";
	sprintf(slask,"<COLUMN_SIZE>%ld</COLUMN_SIZE>",this -> column_size);
	dest += slask;
	sprintf(slask,"<BUFFER_LENGTH>%ld</BUFFER_LENGTH>",this -> buffer_length);
	dest += slask;
	sprintf(slask,"<DECIMAL_DIGITS>%d</DECIMAL_DIGITS>",this -> decimal_digits);
	dest += slask;
	sprintf(slask,"<PSEUDO_COLUMN>%d</PSEUDO_COLUMN>",this -> pseudo_column);
	dest += slask;
	dest += "</ODBCSPECIALCOLUMN>";
	return dest;
}


std::string Odbcspecialcolumn::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ODBCSPECIALCOLUMN " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<SCOPE>%d</SCOPE>",this -> scope);
	dest += slask;
	dest += "<COLUMN_NAME>" + q.GetDatabase().xmlsafestr(this -> column_name) + "</COLUMN_NAME>";
	sprintf(slask,"<DATA_TYPE>%d</DATA_TYPE>",this -> data_type);
	dest += slask;
	dest += "<TYPE_NAME>" + q.GetDatabase().xmlsafestr(this -> type_name) + "</TYPE_NAME>";
	sprintf(slask,"<COLUMN_SIZE>%ld</COLUMN_SIZE>",this -> column_size);
	dest += slask;
	sprintf(slask,"<BUFFER_LENGTH>%ld</BUFFER_LENGTH>",this -> buffer_length);
	dest += slask;
	sprintf(slask,"<DECIMAL_DIGITS>%d</DECIMAL_DIGITS>",this -> decimal_digits);
	dest += slask;
	sprintf(slask,"<PSEUDO_COLUMN>%d</PSEUDO_COLUMN>",this -> pseudo_column);
	dest += slask;
	dest += "</ODBCSPECIALCOLUMN>";
	return dest;
}


size_t Odbcspecialcolumn::num_cols()
{
	return 8;
}


void Odbcspecialcolumn::clear()
{
	this -> scope = 0;
	this -> column_name = "";
	this -> data_type = 0;
	this -> type_name = "";
	this -> column_size = 0;
	this -> buffer_length = 0;
	this -> decimal_digits = 0;
	this -> pseudo_column = 0;
}


void Odbcspecialcolumn::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select scope,column_name,data_type,type_name,column_size,buffer_length,decimal_digits,pseudo_column " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> scope = q.getval(0);																				// 0 - scope smallint
		this -> column_name = q.getstr(1);																				// 1 - column_name varchar(255)
		this -> data_type = q.getval(2);																				// 2 - data_type smallint
		this -> type_name = q.getstr(3);																				// 3 - type_name varchar(255)
		this -> column_size = q.getval(4);																				// 4 - column_size integer
		this -> buffer_length = q.getval(5);																				// 5 - buffer_length integer
		this -> decimal_digits = q.getval(6);																				// 6 - decimal_digits smallint
		this -> pseudo_column = q.getval(7);																				// 7 - pseudo_column smallint
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Odbcspecialcolumn::spawn(Query *qd,int offset)
{
	clear();

	this -> scope = qd -> getval(0 + offset);																				// 0 - scope smallint
	this -> column_name = qd -> getstr(1 + offset);																				// 1 - column_name varchar(255)
	this -> data_type = qd -> getval(2 + offset);																				// 2 - data_type smallint
	this -> type_name = qd -> getstr(3 + offset);																				// 3 - type_name varchar(255)
	this -> column_size = qd -> getval(4 + offset);																				// 4 - column_size integer
	this -> buffer_length = qd -> getval(5 + offset);																				// 5 - buffer_length integer
	this -> decimal_digits = qd -> getval(6 + offset);																				// 6 - decimal_digits smallint
	this -> pseudo_column = qd -> getval(7 + offset);																				// 7 - pseudo_column smallint
}


// End of implementation of class 'Odbcspecialcolumn'

} // End of namespace
namespace sql {

/**
 **  Begin class 'Odbcprimarykey'
 **/

Odbcprimarykey::Odbcprimarykey(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Odbcprimarykey::Odbcprimarykey(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Odbcprimarykey::Odbcprimarykey(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Odbcprimarykey::~Odbcprimarykey()
{
}


void Odbcprimarykey::select(const std::string& sql)
{
	spawn(sql);
}


unsigned __int64 Odbcprimarykey::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into odbcprimarykey(table_cat,table_schem,table_name,column_name,key_seq,pk_name)";
	sql += " values('" + q.GetDatabase().safestr(this -> table_cat) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_schem) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> table_name) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> column_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> key_seq);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> pk_name) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned __int64 inserted_id = q.insert_id();
	return inserted_id;
}


void Odbcprimarykey::save()
{
	if (new_object)
		insert();
}


std::string Odbcprimarykey::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ODBCPRIMARYKEY>";
	dest += "<TABLE_CAT>" + q.GetDatabase().xmlsafestr(this -> table_cat) + "</TABLE_CAT>";
	dest += "<TABLE_SCHEM>" + q.GetDatabase().xmlsafestr(this -> table_schem) + "</TABLE_SCHEM>";
	dest += "<TABLE_NAME>" + q.GetDatabase().xmlsafestr(this -> table_name) + "</TABLE_NAME>";
	dest += "<COLUMN_NAME>" + q.GetDatabase().xmlsafestr(this -> column_name) + "</COLUMN_NAME>";
	sprintf(slask,"<KEY_SEQ>%d</KEY_SEQ>",this -> key_seq);
	dest += slask;
	dest += "<PK_NAME>" + q.GetDatabase().xmlsafestr(this -> pk_name) + "</PK_NAME>";
	dest += "</ODBCPRIMARYKEY>";
	return dest;
}


std::string Odbcprimarykey::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ODBCPRIMARYKEY " + tag + "=\"" + xvalx + "\">";
	dest += "<TABLE_CAT>" + q.GetDatabase().xmlsafestr(this -> table_cat) + "</TABLE_CAT>";
	dest += "<TABLE_SCHEM>" + q.GetDatabase().xmlsafestr(this -> table_schem) + "</TABLE_SCHEM>";
	dest += "<TABLE_NAME>" + q.GetDatabase().xmlsafestr(this -> table_name) + "</TABLE_NAME>";
	dest += "<COLUMN_NAME>" + q.GetDatabase().xmlsafestr(this -> column_name) + "</COLUMN_NAME>";
	sprintf(slask,"<KEY_SEQ>%d</KEY_SEQ>",this -> key_seq);
	dest += slask;
	dest += "<PK_NAME>" + q.GetDatabase().xmlsafestr(this -> pk_name) + "</PK_NAME>";
	dest += "</ODBCPRIMARYKEY>";
	return dest;
}


size_t Odbcprimarykey::num_cols()
{
	return 6;
}


void Odbcprimarykey::clear()
{
	this -> table_cat = "";
	this -> table_schem = "";
	this -> table_name = "";
	this -> column_name = "";
	this -> key_seq = 0;
	this -> pk_name = "";
}


void Odbcprimarykey::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select table_cat,table_schem,table_name,column_name,key_seq,pk_name " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> table_cat = q.getstr(0);																				// 0 - table_cat varchar(255)
		this -> table_schem = q.getstr(1);																				// 1 - table_schem varchar(255)
		this -> table_name = q.getstr(2);																				// 2 - table_name varchar(255)
		this -> column_name = q.getstr(3);																				// 3 - column_name varchar(255)
		this -> key_seq = q.getval(4);																				// 4 - key_seq smallint
		this -> pk_name = q.getstr(5);																				// 5 - pk_name varchar(255)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Odbcprimarykey::spawn(Query *qd,int offset)
{
	clear();

	this -> table_cat = qd -> getstr(0 + offset);																				// 0 - table_cat varchar(255)
	this -> table_schem = qd -> getstr(1 + offset);																				// 1 - table_schem varchar(255)
	this -> table_name = qd -> getstr(2 + offset);																				// 2 - table_name varchar(255)
	this -> column_name = qd -> getstr(3 + offset);																				// 3 - column_name varchar(255)
	this -> key_seq = qd -> getval(4 + offset);																				// 4 - key_seq smallint
	this -> pk_name = qd -> getstr(5 + offset);																				// 5 - pk_name varchar(255)
}


// End of implementation of class 'Odbcprimarykey'

} // End of namespace
